"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _excluded = ["stack"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var fs = require('fs');

var _require = require('jest-message-util'),
    getTopFrame = _require.getTopFrame,
    getStackTraceLines = _require.getStackTraceLines,
    separateMessageFromStack = _require.separateMessageFromStack;

var _require2 = require('@babel/code-frame'),
    codeFrameColumns = _require2.codeFrameColumns;

function pretty(error) {
  var message = error.message,
      stack = error.stack;
  var lines = getStackTraceLines(stack);
  var topFrame = getTopFrame(lines);
  var fallback = "".concat(message).concat(stack);

  if (!topFrame) {
    return fallback;
  }

  var file = topFrame.file,
      line = topFrame.line;

  try {
    var result = codeFrameColumns(fs.readFileSync(file, 'utf8'), {
      start: {
        line: line
      }
    }, {
      highlightCode: true
    });
    return "\n".concat(message, "\n\n").concat(result, "\n").concat(stack, "\n");
  } catch (e) {
    return fallback;
  }
}

function usePrettyErrors(transform) {
  var prepareStackTrace = Error.prepareStackTrace;

  Error.prepareStackTrace = function (error, trace) {
    var prepared = prepareStackTrace ? separateMessageFromStack(prepareStackTrace(error, trace)) : error;
    var transformed = transform ? transform(prepared) : prepared;
    return pretty(transformed);
  };
} // Clean up Webpack's sourcemap namespacing in error stacks
// @see https://github.com/facebook/create-react-app/blob/next/packages/react-dev-utils/formatWebpackMessages.js#L112


var stackTransform = function stackTransform(_ref) {
  var _ref$stack = _ref.stack,
      stack = _ref$stack === void 0 ? '' : _ref$stack,
      rest = (0, _objectWithoutProperties2["default"])(_ref, _excluded);
  return _objectSpread({
    stack: stack.replace('/build/webpack:', '')
  }, rest);
}; // eslint-disable-next-line react-hooks/rules-of-hooks


usePrettyErrors(stackTransform);