"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

// Production webpack config for client code
var _require = require('kyt-utils/paths')(),
    clientSrcPath = _require.clientSrcPath,
    assetsBuildPath = _require.assetsBuildPath;

var _require2 = require('kyt-runtime/webpack'),
    kytWebpackPlugins = _require2.kytWebpackPlugins;

var getPolyfill = require('./getPolyfill');

module.exports = function (options) {
  return {
    mode: 'production',
    target: 'web',
    devtool: 'source-map',
    entry: {
      main: [getPolyfill(options.type), "".concat(clientSrcPath, "/index.js")].filter(Boolean)
    },
    output: {
      path: assetsBuildPath,
      filename: '[name]-[chunkhash].js',
      chunkFilename: '[name]-[chunkhash].js',
      publicPath: options.publicPath
    },
    plugins: (0, _toConsumableArray2["default"])(kytWebpackPlugins(options)),
    optimization: {
      moduleIds: 'hashed',
      runtimeChunk: {
        name: function name(entrypoint) {
          return "runtime~".concat(entrypoint.name);
        }
      },
      splitChunks: {
        cacheGroups: {
          vendor: {
            test: /[\\/]node_modules[\\/]/,
            name: 'vendor',
            chunks: 'all',
            minChunks: 2
          }
        }
      }
    }
  };
};